<?php

/**
 * Nav Menu Item
 *
 * @author Mat Lipe
 * @since  3.3.3
 *
 */
class Advanced_Sidebar_Menu_Pro__Nav_Menu__Item {
	protected $menu_item;
	/**
	 * objects
	 *
	 * @var Advanced_Sidebar_Menu_Pro__Nav_Menu__Nav_Menu_Objects
	 */
	protected $objects;

	public $current;
	public $current_item_ancestor;
	public $menu_item_parent;


	public function get_id() {
		return (int) $this->menu_item->ID;
	}


	/**
	 *
	 *
	 * @return Advanced_Sidebar_Menu_Pro__Nav_Menu__Item[]
	 */
	public function get_children() {
		return $this->objects->get_child_items( $this->menu_item->ID );
	}


	/**
	 *
	 *
	 * @return bool|Advanced_Sidebar_Menu_Pro__Nav_Menu__Item
	 */
	public function get_parent() {
		if ( 0 === (int) $this->menu_item_parent ) {
			return false;
		}

		return $this->objects->get_item( $this->menu_item_parent );

	}


	/**
	 * If this item or a parent/grandparent of this item is excluded
	 *
	 * @return bool
	 */
	public function is_excluded() {
		//@todo make this follow the meta box settings
		$excluded = false;

		if ( false === $excluded ) {
			$parent = $this->get_parent();
			if ( false !== $parent ) {
				$excluded = $parent->is_excluded();
			}
		}

		return $excluded;
	}


	public function is_in_current_family() {
		return $this->objects->is_in_current_family( $this->get_id() );
	}


	public function get_title() {
		//@todo make this follow the meta box settings
		return $this->menu_item->post_title;

	}


	public function get() {
		$post             = $this->menu_item;
		$post->post_title = $this->get_title();

		return $post;
	}


	public static function factory( WP_Post $menu_item, Advanced_Sidebar_Menu_Pro__Nav_Menu__Nav_Menu_Objects $objects ) {
		$item                        = new  self();
		$item->menu_item             = $menu_item;
		$item->objects               = $objects;
		$item->current               = $menu_item->current;
		$item->current_item_ancestor = $menu_item->current_item_ancestor;
		$item->menu_item_parent      = $menu_item->menu_item_parent;

		return $item;

	}
}
