<?php

/**
 * Advanced_Sidebar_Menu_Pro__Widget_Options__Fields
 *
 * @author Mat Lipe
 * @since  3.0.0
 *
 * @todo   generate additional fields like text() and select()
 *
 */
abstract class Advanced_Sidebar_Menu_Pro__Widget_Options__Fields {

	/**
	 * Checks if a widgets checkbox is checked.
	 *
	 * Checks first for a value then verifies the value = checked
	 *
	 * @param string $name - name of checkbox.
	 * @param array  $instance
	 *
	 * @since 3.1.0
	 *
	 * @return bool
	 */
	public function checked( $name, array $instance ) {
		return isset( $instance[ $name ] ) && 'checked' === $instance[ $name ];
	}
}
